commit af97492c9e295acd95e63c1565cb94f7853e55ec
Author: Gao,Yan <ygao@suse.com>
Date:   Tue Aug 11 16:53:14 2015 +0200

    Test: pengine: Ensure fencing of the DC precedes the STONITH_DONE operation (update regression tests)

diff --git a/pengine/test10/rec-node-14.dot b/pengine/test10/rec-node-14.dot
index 395fa89..5ceef92 100644
--- a/pengine/test10/rec-node-14.dot
+++ b/pengine/test10/rec-node-14.dot
@@ -2,9 +2,9 @@
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
 "stonith 'reboot' node1" -> "stonith 'reboot' node3" [ style = bold]
 "stonith 'reboot' node1" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' node2" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' node2" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' node3" -> "stonith 'reboot' node2" [ style = bold]
-"stonith 'reboot' node3" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' node3" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/rec-node-14.exp b/pengine/test10/rec-node-14.exp
index 58bb5ca..0e5e163 100644
--- a/pengine/test10/rec-node-14.exp
+++ b/pengine/test10/rec-node-14.exp
@@ -39,7 +39,7 @@
      </action_set>
      <inputs>
        <trigger>
-        <crm_event id="5" operation="stonith" operation_key="stonith-node3-reboot" on_node="node3" on_node_uuid="uuid3"/>
+        <crm_event id="4" operation="stonith" operation_key="stonith-node2-reboot" on_node="node2" on_node_uuid="uuid2"/>
        </trigger>
      </inputs>
    </synapse>
diff --git a/pengine/test10/stonith-0.dot b/pengine/test10/stonith-0.dot
index 29cdd59..8ad32fd 100644
--- a/pengine/test10/stonith-0.dot
+++ b/pengine/test10/stonith-0.dot
@@ -71,13 +71,13 @@ digraph "g" {
 "stonith 'reboot' c001n03" -> "ocf_192.168.100.181_stop_0 c001n03" [ style = bold]
 "stonith 'reboot' c001n03" -> "ocf_192.168.100.183_stop_0 c001n03" [ style = bold]
 "stonith 'reboot' c001n03" -> "rsc_c001n07_stop_0 c001n03" [ style = bold]
+"stonith 'reboot' c001n03" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' c001n03" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' c001n05" -> "group-1_stop_0" [ style = bold]
 "stonith 'reboot' c001n05" -> "ocf_192.168.100.181_stop_0 c001n05" [ style = bold]
 "stonith 'reboot' c001n05" -> "ocf_192.168.100.183_stop_0 c001n05" [ style = bold]
 "stonith 'reboot' c001n05" -> "rsc_c001n05_stop_0 c001n05" [ style = bold]
 "stonith 'reboot' c001n05" -> "stonith 'reboot' c001n03" [ style = bold]
-"stonith 'reboot' c001n05" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' c001n05" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" -> "heartbeat_192.168.100.182_start_0 c001n02" [ style = bold]
diff --git a/pengine/test10/stonith-0.exp b/pengine/test10/stonith-0.exp
index 9d47215..a6695c9 100644
--- a/pengine/test10/stonith-0.exp
+++ b/pengine/test10/stonith-0.exp
@@ -394,7 +394,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="111" operation="stonith" operation_key="stonith-c001n05-reboot" on_node="c001n05" on_node_uuid="52a5ea5e-86ee-442c-b251-0bc9825c517e"/>
+        <crm_event id="110" operation="stonith" operation_key="stonith-c001n03-reboot" on_node="c001n03" on_node_uuid="f5e1d2de-73da-432a-9d5c-37472253c2ee"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/systemhealth1.dot b/pengine/test10/systemhealth1.dot
index 28841b7..a29f519 100644
--- a/pengine/test10/systemhealth1.dot
+++ b/pengine/test10/systemhealth1.dot
@@ -1,8 +1,8 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"stonith 'reboot' hs21c" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21c" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' hs21d" -> "stonith 'reboot' hs21c" [ style = bold]
-"stonith 'reboot' hs21d" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21d" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/systemhealth1.exp b/pengine/test10/systemhealth1.exp
index 80a2329..aa2afe1 100644
--- a/pengine/test10/systemhealth1.exp
+++ b/pengine/test10/systemhealth1.exp
@@ -27,7 +27,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-hs21d-reboot" on_node="hs21d" on_node_uuid="737318c6-0f92-4592-9754-45967d45aff7"/>
+        <crm_event id="3" operation="stonith" operation_key="stonith-hs21c-reboot" on_node="hs21c" on_node_uuid="c97a3ee5-02d8-4fad-a9fb-a79ae2b35549"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/systemhealthm1.dot b/pengine/test10/systemhealthm1.dot
index 28841b7..a29f519 100644
--- a/pengine/test10/systemhealthm1.dot
+++ b/pengine/test10/systemhealthm1.dot
@@ -1,8 +1,8 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"stonith 'reboot' hs21c" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21c" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' hs21d" -> "stonith 'reboot' hs21c" [ style = bold]
-"stonith 'reboot' hs21d" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21d" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/systemhealthm1.exp b/pengine/test10/systemhealthm1.exp
index 80a2329..aa2afe1 100644
--- a/pengine/test10/systemhealthm1.exp
+++ b/pengine/test10/systemhealthm1.exp
@@ -27,7 +27,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-hs21d-reboot" on_node="hs21d" on_node_uuid="737318c6-0f92-4592-9754-45967d45aff7"/>
+        <crm_event id="3" operation="stonith" operation_key="stonith-hs21c-reboot" on_node="hs21c" on_node_uuid="c97a3ee5-02d8-4fad-a9fb-a79ae2b35549"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/systemhealthn1.dot b/pengine/test10/systemhealthn1.dot
index 28841b7..a29f519 100644
--- a/pengine/test10/systemhealthn1.dot
+++ b/pengine/test10/systemhealthn1.dot
@@ -1,8 +1,8 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"stonith 'reboot' hs21c" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21c" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' hs21d" -> "stonith 'reboot' hs21c" [ style = bold]
-"stonith 'reboot' hs21d" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21d" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/systemhealthn1.exp b/pengine/test10/systemhealthn1.exp
index 80a2329..aa2afe1 100644
--- a/pengine/test10/systemhealthn1.exp
+++ b/pengine/test10/systemhealthn1.exp
@@ -27,7 +27,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-hs21d-reboot" on_node="hs21d" on_node_uuid="737318c6-0f92-4592-9754-45967d45aff7"/>
+        <crm_event id="3" operation="stonith" operation_key="stonith-hs21c-reboot" on_node="hs21c" on_node_uuid="c97a3ee5-02d8-4fad-a9fb-a79ae2b35549"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/systemhealtho1.dot b/pengine/test10/systemhealtho1.dot
index 28841b7..a29f519 100644
--- a/pengine/test10/systemhealtho1.dot
+++ b/pengine/test10/systemhealtho1.dot
@@ -1,8 +1,8 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"stonith 'reboot' hs21c" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21c" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' hs21d" -> "stonith 'reboot' hs21c" [ style = bold]
-"stonith 'reboot' hs21d" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21d" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/systemhealtho1.exp b/pengine/test10/systemhealtho1.exp
index 80a2329..aa2afe1 100644
--- a/pengine/test10/systemhealtho1.exp
+++ b/pengine/test10/systemhealtho1.exp
@@ -27,7 +27,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-hs21d-reboot" on_node="hs21d" on_node_uuid="737318c6-0f92-4592-9754-45967d45aff7"/>
+        <crm_event id="3" operation="stonith" operation_key="stonith-hs21c-reboot" on_node="hs21c" on_node_uuid="c97a3ee5-02d8-4fad-a9fb-a79ae2b35549"/>
       </trigger>
     </inputs>
   </synapse>
diff --git a/pengine/test10/systemhealthp1.dot b/pengine/test10/systemhealthp1.dot
index 28841b7..a29f519 100644
--- a/pengine/test10/systemhealthp1.dot
+++ b/pengine/test10/systemhealthp1.dot
@@ -1,8 +1,8 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"stonith 'reboot' hs21c" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21c" [ style=bold color="green" fontcolor="black"]
 "stonith 'reboot' hs21d" -> "stonith 'reboot' hs21c" [ style = bold]
-"stonith 'reboot' hs21d" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' hs21d" [ style=bold color="green" fontcolor="black"]
 "stonith_complete" -> "all_stopped" [ style = bold]
 "stonith_complete" [ style=bold color="green" fontcolor="orange" ]
diff --git a/pengine/test10/systemhealthp1.exp b/pengine/test10/systemhealthp1.exp
index 80a2329..aa2afe1 100644
--- a/pengine/test10/systemhealthp1.exp
+++ b/pengine/test10/systemhealthp1.exp
@@ -27,7 +27,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="4" operation="stonith" operation_key="stonith-hs21d-reboot" on_node="hs21d" on_node_uuid="737318c6-0f92-4592-9754-45967d45aff7"/>
+        <crm_event id="3" operation="stonith" operation_key="stonith-hs21c-reboot" on_node="hs21c" on_node_uuid="c97a3ee5-02d8-4fad-a9fb-a79ae2b35549"/>
       </trigger>
     </inputs>
   </synapse>